#include "shiftRegister8.h"
#include <avr/pgmspace.h>

shiftRegister8::shiftRegister8() { }
shiftRegister8::~shiftRegister8() { }

void shiftRegister8::begin(byte dataPin, byte latchPin, byte clockPin) {
  this->registerState = B00000000;
  this->autoUpdate = true;
  this->updateRegister = true;
  this->dataPin = dataPin;
  this->latchPin = latchPin;
  this->clockPin = clockPin;
  pinMode(this->dataPin, OUTPUT);
  pinMode(this->clockPin, OUTPUT);
  pinMode(this->latchPin, OUTPUT);
  update();
}

void shiftRegister8::set(byte bitMask, boolean setting) {
  if (setting && ((this->registerState & bitMask) == 0)) {
    this->registerState |= bitMask;
    this->updateRegister = true;
    if (this->autoUpdate) update();
  } else if (!setting && ((this->registerState & bitMask) > 0)) {
    this->registerState &= ~bitMask;
    this->updateRegister = true;
    if (this->autoUpdate) update();
  }
}

void shiftRegister8::update(void) {
  // update the shift register
  if (this->updateRegister) {
    digitalWrite(this->latchPin, LOW);
    shiftOut(this->dataPin, this->clockPin, MSBFIRST, this->registerState);
    digitalWrite(this->latchPin, HIGH);
    this->updateRegister = false;
  }
}
